from PyMata.pymata import PyMata
import time

arduino_path = "/dev/ttyACM0"

def init(path):
	board = PyMata(path)

	for pin in range(17):
		board.set_pin_mode(pin + 2, board.OUTPUT, board.DIGITAL)

	return board

def getMapping():
	mapping = []
	for i in range(17):
		m = input("Mapping of index %d [2~18]: "%i)
		mapping.append(m)
	return mapping

disp_vector = [
	[0, 1, 3, 5, 6, 7, 8, 15],
	[3, 4, 7, 8],
	[1, 4, 5, 6, 11, 16],
	[4, 6, 8, 11, 16],
	[1, 4, 5, 6, 9, 10],
	[0, 4, 6, 8, 9, 10, 15],
	[0, 3, 4, 6, 7, 12, 15],
	[0, 1, 2, 3, 4, 7, 8, 12, 15, 16],
	[0, 5, 6, 7, 12, 15, 16],
	[0, 3, 7, 8, 9, 15],
	[1, 2, 3, 4, 5, 6, 9, 12],
	[1, 4, 8, 10],
	[3, 5, 7, 10, 16],
	[3, 5, 6, 7],
	[0, 1, 3, 4, 6, 7, 8, 12, 15, 16],
	[0, 1, 3, 4, 7, 8, 11, 12, 15, 16],
	[0, 1, 3, 4, 8, 12, 15],
	[0, 1, 3, 4, 8, 10, 11, 12, 15, 16],
	[10, 11, 16],
	[1, 4, 8, 11, 16],
	[0, 3, 6, 7, 8, 15],
	[0, 1, 3, 5, 12, 15, 16],
	[0, 5, 7, 12],
	[0, 1, 5, 6, 7, 11],
	[1, 4, 5, 7, 10, 11, 16],
	[3, 5, 6, 8, 9, 10, 12, 14],
	[1, 3, 4, 5, 6, 9, 12, 14],
	[0, 1, 4, 5, 6, 8, 11],
	[2, 7, 11, 12, 15],
	[1, 2, 3, 5, 7, 8, 10, 14],
	[4, 7, 8, 10, 14],
	[0, 1, 3, 4, 5, 6, 7, 12, 15],
	[3, 4, 6, 7, 12],
	[4, 7, 8, 9, 14],
	[6, 7, 8, 9, 12, 14, 16],
	[4, 7, 8, 12, 14, 16],
	[3, 4, 8, 12, 14, 16],
	[0, 1, 3, 5, 6, 7, 8, 15, 16],
	[0, 3, 4, 6, 7, 15],
	[1, 5, 7, 8, 11, 15, 16],
	[0, 1, 3, 4, 5, 6, 7, 8, 11, 12, 16],
	[0, 1, 3, 5, 6, 8, 12, 15],
	[1, 4, 5, 8],
	[1, 3, 5, 12, 14],
	[0, 1, 4, 5, 6, 10, 15],
	[1, 3, 4, 5, 6, 10, 11, 12, 14, 16],
	[0, 1, 5, 11, 15, 16],
	[0, 3, 11, 12, 15, 16],
	[3, 4, 6, 8, 11, 12, 16],
	[0, 1, 5, 6, 8, 10, 15],
	[0, 4, 10, 16],
	[0, 4, 5, 8, 16],
	[0, 1, 6, 15],
	[3, 4, 7],
	[2, 3, 6, 8, 14],
]

if __name__ == '__main__':
	mapping = getMapping()
	board = init(arduino_path)

	while True:
		seg = [1] * 17

		for v in disp_vector:
			for i in v:
				seg[i] = 1 - seg[i]

			for (idx, val) in zip(list(range(17)), seg):
				board.digital_write(mapping[idx], val)
			time.sleep(1)

