import unittest
# from updates.exploit.update import *


def compare_loss(id_correct, id_corrupted):
    return sum(ch1 != ch2 and ch2 != ' ' for ch1, ch2 in zip(id_correct, id_corrupted))


class TestExploit(unittest.TestCase):
    def test_compare_loss(self):
        self.assertEqual(compare_loss("abcdefghijklm", "abc ef hi klm"), 0)
        self.assertEqual(compare_loss("abc ef hi klm", "abcdefghijklm"), 3)
        self.assertEqual(compare_loss("abcdefghijklm", "abcdefghijklm"), 0)

    def test_process_message(self):
        device = "8028345879897239058462938574623985746293853094857"
        message = "FLAGFLAGFLAG8028345879"
        flag_sender_id = message[12:22]
        self.assertTrue(compare_loss(device[:10], flag_sender_id) < 1)

        message = "F AGFL GFLAG8028 458 9"
        flag_sender_id = message[12:22]
        self.assertTrue(compare_loss(device[:10], flag_sender_id) < 1)


if __name__ == '__main__':
    unittest.main()
